import { Actor, ActorCons, ActorRef } from "./Actor";
import { Address, Channel } from "./interfaces";
export declare class ActorSystem {
    name: string;
    protected actorRegistry: {
        [address: string]: Actor;
    };
    private actorSystemRegistry;
    constructor(name?: string);
    register(emitter: Channel): void;
    unregister(actorSystemAddress: string): void;
    listenTo(emitter: Channel): void;
    createActor: <T extends Actor>(name: string, Class: ActorCons<T>) => ActorRef<Pick<T, { [K in Exclude<keyof T, "at" | "atSelf" | "onNewMessage" | "pushToMailbox" | "ref">]: T[K] extends (...args: any[]) => infer R ? R extends Promise<any> ? K : never : never; }[Exclude<keyof T, "at" | "atSelf" | "onNewMessage" | "pushToMailbox" | "ref">]>>;
    ref: <T>(address: Address) => ActorRef<T>;
    findActor: <T>(address: Address) => ActorRef<T> | null;
    sendMessage: (target: Address | ActorRef<any>, type: string, payload: any, senderAddress: Address | null) => Promise<any>;
    isLocalAddress(address: Address): boolean;
    private log(...message);
}
