import { CancellablePromise } from "./Utils";
export declare type Message = {};
export declare type BaseActorDefinition = {
    [key: string]: (...payload: any[]) => Promise<any> | CancellablePromise<any>;
};
export declare type ActorSystemAdress = string;
export declare type LocalAddress = string;
export declare type Address = {
    actorSystemName: ActorSystemAdress;
    localAddress: LocalAddress;
};
export declare type Handler<T> = {
    [P in keyof T]: T[P];
};
export declare type Channel = {
    on: (event: "message" | "disconnect" | "reconnect", fn: (message: InterActorSystemMessage, callback: (message: any) => void) => void) => void;
    emit: (event: string, message: InterActorSystemMessage, callback?: (message: any) => void) => void;
};
export declare type InterActorSystemMessage = {
    mode: "send" | "ask";
    type: string;
    payload: {};
    targetAddress: Address;
    senderAddress: Address | null;
} | {
    mode: "handshake";
    address: string;
};
